<?php
// $Id: profile_pictures_field.inc,v 1.1 2010/04/09 20:27:27 yeputons Exp $
/**
 * @file
 *   Profile picture field handler (views)
 */

class profile_pictures_field extends views_handler_field {
  function option_definition() {
    $options = parent::option_definition();
    $options['max_height'] = array('default' => 0);
    $options['max_width'] = array('default' => 0);
    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);

    $form['max_height'] = array(
      '#type' => 'textfield',
      '#title' => t('Maximum height (0 for no limit)'),
      '#default_value' => $this->options['max_height'],
    );
    $form['max_width'] = array(
      '#type' => 'textfield',
      '#title' => t('Maximum width (0 for no limit)'),
      '#default_value' => $this->options['max_width'],
    );
  }
  function options_validate(&$form, &$form_state) {
    $v = $form_state['values']['options']['max_height'];
    if (!is_numeric($v) || ($v < 0))
      form_set_error('max_height', t('Maximum height must be a non-negative integer'));

    $v = $form_state['values']['options']['max_width'];
    if (!is_numeric($v) || ($v < 0))
      form_set_error('max_width', t('Maximum width must be non-negative integer'));  
  }

  function render($values) {
    drupal_add_css(drupal_get_path('module', 'profile_pictures') . '/profile_pictures.css', 'module');

    if ($this->options['max_height'] > 0) {
      $maxh = (int)$this->options['max_height'];
    }
    if ($this->options['max_width'] > 0) {
      $maxw = (int)$this->options['max_width'];
    }

    // Calculating output image size (given maximum dimensions).
    // We need to calculate both width and height to output its
    // like CSS attributes.
    list($width, $height) = @getimagesize($values->{$this->field_alias});
    if ($maxh && ($height > $maxh)) {
      $width *= $maxh / $height;
      $height = $maxh;
    }
    if ($maxw && ($width > $maxw)) {
      $height *= $maxw / $width;
      $width = $maxw;
    }

    return theme('image', $values->{$this->field_alias}, $this->options['label'], '',
      array(
      'class' => 'profile_pictures_field',
      'style' => 'width:' . $width . 'px; height:' . $height . 'px;',
    ));
  }
}
